﻿/**
 * Демо проект, использующий движок ТММ 3
 * @author Werdn
 * @version 1.0
 *
	TMM III - simulator of plain mechanisms
	Copyright (C) 2007  Andrey Motrenko (werdn666@yandex.ru)
	
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
import flash.Lib;
import flash.MovieClip;
import ru.narod.werdn666.tmm3.Engine;
import ru.narod.werdn666.tmm3.MechLoader;
import flash.external.ExternalInterface;

/**
 * Демо проект, использующий движок ТММ
 */
class Main extends MovieClip
{
	/**
	 * Движок ТММ
	 */
	var e:Engine;
	
	/**
	 * Конструктор
	 */
	public function new()
	{
		this.cacheAsBitmap = true;
		e = new Engine(this);
		DoAddCallback('OpenFile', doLoadXmlFile);
		/**
		 * Загрузка тестовой схемы
		 */
		doLoadXmlFile('tmm.xml');
		e.start();
	}
		
	/**
	 * начало программы
	 */
	static function main()
	{
		var m:Main = cast(Lib._root.attachMovie('Main', 'm', 10));
	}
	
	/**
	 * Загрузка файла
	 * @param	file	-	имя файла
	 */
	private function doLoadXmlFile(file:String)
	{
		var loader:MechLoader = new MechLoader(e);
		loader.load(file, this);
	}
	
	/**
	 * Добавляет CallBack для плеера
	 * @param	name	-	имя функции извне
	 * @param	fun		-	внутренняя функция
	 */
	private function DoAddCallback(name:String, fun:Dynamic)
	{
		var methodName:String = name;
		var instance:Dynamic = null;
		var method:Dynamic = fun;
		
		var wasSuccessful:Bool = ExternalInterface.addCallback(methodName, instance, method);
	}
}