﻿/**
 * Вспомогательный класс для выполнения расчетов и рисования примитивов
 * @author Werdn
 * @version 1.0
 * 
	TMM III - simulator of plain mechanisms
	Copyright (C) 2007  Andrey Motrenko (werdn666@yandex.ru)
	
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package ru.narod.werdn666.tmm3.graphics;

import flash.Accessibility;
import flash.geom.Point;
import flash.MovieClip;
import flash.geom.Point;

/**
 * Вспомогательный класс для выполнения расчетов и рисования примитивов
 */
class Graphics 
{
	/**
	 * Приватный конструктор
	 */
	private function new() 
	{
		
	}
	
	/**
	 * Рисование окружности. (взято из какой-то умной книжки)
	 * Параметры цвета необходимо задать предварительно
	 * @param	mc	- 	место для рисования
	 * @param	x 	- 	координата X окружности
	 * @param	y 	- 	координата Y окружности
	 * @param	r 	- 	радиус окружности
	 */
	public static function paintCircle (mc:MovieClip, x:Float, y:Float, r:Float):Void 
	{
		var mtp8r:Float = Math.tan(Math.PI/8) * r;
		var msp4r:Float = Math.sin(Math.PI/4) * r;
		
		mc.moveTo(x + r, y);
		mc.curveTo(r + x, mtp8r + y, msp4r + x, msp4r + y);
		mc.curveTo(mtp8r + x, r + y, x, r + y);
		mc.curveTo(-mtp8r + x, r + y, -msp4r + x, msp4r + y);
		mc.curveTo(-r + x, mtp8r + y, -r + x, y);
		mc.curveTo(-r + x, -mtp8r + y, -msp4r + x, -msp4r + y);
		mc.curveTo(-mtp8r + x, -r + y, x, -r + y);
		mc.curveTo(mtp8r + x, -r + y, msp4r + x, -msp4r + y);
		mc.curveTo(r + x, -mtp8r + y, r + x, y);
	}
	
	/**
	 * Расчет угла наклона прямой по двум точкам
	 * @param	p1	-	начало отрезка
	 * @param	p2 	- 	конец отрезка
	 * @return
	 */
	public static function getAngle(p1:Point<Float>, p2:Point<Float>):Float
	{
		if(p1.equals(p2))
		{
			return 0;
		}
		var t:Float = Math.atan2 (-0.000001 + p2.y - p1.y, p2.x - p1.x);
		return t;//a;
	}
	
	/**
	 * Нахождение расстояния от точки P до прямой AB
	 * @param	p	-	коотдинаты точки P
	 * @param	a	-	коотдинаты точки A
	 * @param	b	-	коотдинаты точки B
	 * @return	возвращает расстояние
	 */
	public static function distanceToLine(p:Point<Float>, a:Point<Float>, b:Point<Float>):Float
	{
		return Math.abs((p.x - a.x) * (b.y - a.y) - (p.y - a.y) * (b.x - a.x)) / Point.distance(a, b);
	}
	
}
