/**
 *    ()
 * @author Werdn
 * @version 1.0
 * 
	TMM III - simulator of plain mechanisms
	Copyright (C) 2007  Andrey Motrenko (werdn666@yandex.ru)
	
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package ru.narod.werdn666.tmm3.groups;

import flash.geom.Point;
import flash.MovieClip;
import ru.narod.werdn666.tmm3.vertices.Vertex;
import ru.narod.werdn666.tmm3.groups.Group;
import ru.narod.werdn666.tmm3.graphics.Graphics;

/**
 *    ()
 */
class CrankGroup extends Group
{
	public var p1:Vertex;
	public var p2:Vertex;

	public var omega:Float;
	
	public var length:Float;
	public var angle:Float;
	
	public static var dt:Float = .1;

	/**
	 * 
	 * @param	ground	-	 
	 * @param	mover	-	 
	 */
	public function new(ground:Vertex, mover:Vertex) 
	{
		super();
		
		p1 = ground;
		p2 = mover;
		
		length = Point.distance(p1.center, p2.center);
		angle = Graphics.getAngle(p1.center, p2.center);
		omega = 1;
	}
	
	/**
	 *      
	 */
	public function calc()
	{
		angle += dt;
		var sa:Float = Math.sin(angle);
		var ca:Float = Math.cos(angle);
		p2.center.x = p1.center.x + length * ca;
		p2.center.y = p1.center.y + length * sa;
		
		var vp2:Float = omega * length;
		p2.speed = Point.polar(vp2, angle + Math.PI / 2).add(p1.speed);
		
		p1.painted = false;
		p2.painted = false;
	}
	
	/**
	 *     
	 * @param	mc	-	  
	 */
	public function paint(mc:MovieClip)
	{
		if(p1 != null && p2 != null)
		{
			mc.lineStyle(1, color);
			mc.moveTo(p1.center.x, p1.center.y);
			mc.lineTo(p2.center.x, p2.center.y);
			
			p1.paint(mc);
			p2.paint(mc);
		}
	}
	
}