﻿/**
 * Характерная точка механизма (опора, шарнир и т. д.)
 * @author Werdn
 * @version 1.0
 * 
	TMM III - simulator of plain mechanisms
	Copyright (C) 2007  Andrey Motrenko (werdn666@yandex.ru)
	
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package ru.narod.werdn666.tmm3.vertices;

import flash.Boot;
import flash.geom.Point;
import flash.MovieClip;

/**
 * Характерная точка механизма (опора, шарнир и т. д.)
 */
class Vertex 
{
	/**
	 * Цвет точки
	 */
	public var color:Int;
	
	/**
	 * Координаты точки
	 */
	public var center:Point<Float>;
	
	/**
	 * Угол наклона элемента, закрепленного в точке
	 */
	public var angle:Float;
	
	/**
	 * Кинематические параметры
	 */
	public var speed:Point<Float>;
	public var vectorSpeed:Bool;
	
	/**
	 * Признак отрисованности
	 */
	public var painted:Bool;
	
	/**
	 * Конструктор
	 * @param	X	-	координата
	 * @param	Y	-	координата
	 */
	public function new(X:Float, Y:Float) 
	{
		center = new Point<Float>(X, Y);
		speed = new Point<Float>(0, 0);
		color = 0x127CC2;
		angle = 0;
		vectorSpeed = false;
	}
	
	/**
	* Рисование вершины
	* @param	mc	-	место для рисования
	*/
	public function paint(mc:MovieClip)
	{
		mc.lineStyle(1, color);
	
		if(vectorSpeed)
		{
			mc.moveTo(center.x, center.y);
			mc.lineTo(center.x + speed.x, center.y + speed.y);
			mc.moveTo(center.x, center.y);
		}
	}
	
}